﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr174_1
{
    // Объявление первого делегата: 
    delegate int Alpha(int n);
    
    // Объявление второго делегата: 
    delegate void Bravo(string t);

    // Класс: 
    class MyClass {
        // Открытое целочисленное поле: 
        public int number;
        // Конструктор: 
        public MyClass(int n) {
            number = n; // Значение поля
        }
        // Поле, являющееся ссылкой на экземпляр делегата: 
        public Alpha method;
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Создание объектов:
            MyClass A = new MyClass(100);
            MyClass B = new MyClass(200);
            // Полю объекта значением присваивается 
            // анонимный метод:
            A.method = delegate(int n) {
                return A.number + n;
            };
            // Полю объекта значением присваивается 
            // анонимный метод:
            B.method = delegate(int n) {
                return B.number - n;
            };
            // Целочисленная переменная: 
            int x = 80;
            // Вызов экземпляра делегата:
            Console.WriteLine("A.method({0}) = {1}", x, A.method(x));
            // Присваивание нового значения полю:
            A.number = 300;
            // Вызов экземпляров делегата:
            Console.WriteLine("A.method({0}) = {1}", x, A.method(x));
            Console.WriteLine("B.method({0}) = {1}", x, B.method(x));
            // Объявление переменной типа делегата:
            Bravo show;
            // Присваивание переменной анонимного метода: 
            show = delegate(string t) {
                Console.WriteLine("Teкст: \"{0}\"", t);
            };
            // Вызов экземпляра делегата: 
            show("Bravo");
            // Присваивание переменной анонимного метода:  
            show = delegate(string t) {
                for(int k = 0; k < t.Length; k++) {
                    Console.Write("|" + t[k]);
                }
                Console.WriteLine("|");
            };
            // Вызов экземпляра делегата: 
            show("Bravo");
            // Задержка:
            Console.ReadLine();
        }
    }
}
